package com.liquidnet.service.zxlnft.test;

import com.liquidnet.common.third.zxlnft.biz.ZxlnftBiz;
import com.liquidnet.common.third.zxlnft.config.ZxlnftConfig;
import com.liquidnet.common.third.zxlnft.dto.nft.Nft016IdentityBindQueryReq;
import com.liquidnet.common.third.zxlnft.dto.nft.Nft016IdentityBindQueryResp;
import com.liquidnet.common.third.zxlnft.dto.nft.Nft022UploadSecretReq;
import com.liquidnet.common.third.zxlnft.dto.nft.Nft022UploadSecretResp;
import com.liquidnet.common.third.zxlnft.util.ZxlWalletSdkUtil;
import com.liquidnet.common.third.zxlnft.util.ZxlnftSdkUtil;
import com.liquidnet.commons.lang.util.DateUtil;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

/**
 * @author AnJiabin <anjiabin@zhengzai.tv>
 * @version V1.0
 * @Description: TODO
 * @class: TestZxlnftSdkUtil
 * @Package com.liquidnet.common.third.zxlnft.test
 * @Copyright: LightNet @ Copyright (c) 2021
 * @date 2022/2/18 13:49
 */
@Slf4j
@RunWith(SpringJUnit4ClassRunner.class)
@SpringBootTest
public class TestZxlnftSdkUtil {
    @Autowired
    private ZxlWalletSdkUtil zxlWalletSdkUtil;

    @Autowired
    private ZxlnftSdkUtil zxlnftSdkUtil;

    @Autowired
    private ZxlnftConfig zxlnftConfig;

    @Autowired
    private ZxlnftBiz zxlnftBiz;

    @Test
    public void nft016IdentityBindQuery(){
        Nft016IdentityBindQueryReq req = Nft016IdentityBindQueryReq.getNew();

        Nft016IdentityBindQueryResp resp = zxlnftSdkUtil.nft016IdentityBindQuery(req);
    }

    @Test
    public void nft022UploadSecret(){
        Nft022UploadSecretReq req = Nft022UploadSecretReq.getNew();
//        req.setSeriesName("");
        req.setTimestamp(DateUtil.getNowSeconds().toString());
        req.setPubKey(zxlnftConfig.getNftPlatformPubKey());
        req.setUserPubKey(zxlnftConfig.getNftPlatformPubKey());

        //系列为空
        String pubData = req.getTimestamp() + "_" + req.getUserPubKey();
        String userData = req.getTimestamp();
        //系列不为空
//        String pubData = req.getTimestamp() + "_" + req.getSeriesName() + "_" + req.getUserPubKey();
//        String userData = req.getTimestamp() + "_" + req.getSeriesName();

        req.setPubSignedData(zxlnftBiz.createSign(zxlnftConfig.getNftPlatformPriKey(),pubData));
        req.setUserSignedData(zxlnftBiz.createSign(zxlnftConfig.getNftPlatformPriKey(),userData));

        Nft022UploadSecretResp resp = zxlnftSdkUtil.nft022UploadSecret(req);
    }
}
